!!****J* QTLMap/qtlmap-check
!!  NAME
!!   qtlmap-check
!!  DESCRIPTION
!!   check file format
!!  BUGS
!!
!!  SEE ALSO
!!
!!    http://www.inra.fr/qtlmap
!!
!!  CREATION DATE
!!  15/03/2012
!!
!!  COPYRIGHT
!!***
program toCarthagene
      use m_qtlmap_log
      use m_qtlmap_constant
      use m_qtlmap_types
      use m_qtlmap_haplotype
      use m_qtlmap_genealogy
      use m_qtlmap_genotype
      use m_qtlmap_map
      use m_qtlmap_format_carthagene
      use m_qtlmap_output_handler

    implicit none

    character(len=LENGTH_MAX_FILE) :: outfile,param
    character(len=LEN_DEF)                  :: token
    integer :: stat,unit_genotype,nmarker_in_genotype_file,ios,type_out
    character(len=LEN_LINE*10)       :: line_read,temp
    logical :: is_ok
    integer :: nkeys = 0,c
    character(len=LEN_DEF) ,dimension(30) :: listKeys,listValues
    character(len=LEN_L) ,dimension(200) :: index_key,values
    type(QTLMAP_DATASET)       :: dataset
    type(PDD_BUILD)            :: spt

    call dataset%set()

    if (dataset%cli%cli_is_help()) then
         print *," ********************************************************************************** "
         print *," ** Check input files using the parameter analyse file. "
         print *,""
         stop
    end if


    ! ----- INIT LOG LEVEL
    call init_log(INFO_DEF)
    if (dataset%cli%cli_is_quiet()) call init_log(ERROR_DEF)
    if (dataset%cli%cli_is_verbose()) call init_log(VERBOSE_DEF)
    if (dataset%cli%cli_is_debug()) call init_log(DEBUG_DEF)

    ! ------ GETTING PARAMETER FILE
    param = dataset%cli%cli_get_parameters_file()
       !----- Give information about library used by the program
    call MATH_QTLMAP_INFO

    ! ------ READING PARAMETER FILE
    call dataset%set_parameters_qtlmap_dataset(dataset%cli%cli_get_parameters_file())

    call dataset%params%get_summary_panalyse(index_key,values,c)
    call print_summary_panalyse(c,index_key,values)

    call check_and_print_correc_genealogy(dataset)

    call read_map(dataset,.true.)
    call read_genotype(dataset)

    call check_genotype(dataset,spt)

    call dataset%release()




end program toCarthagene
